package de.accso.flexinale.ticketing.infrastructure.persistence;

import de.accso.flexinale.common.shared_kernel.Identifiable;
import de.accso.flexinale.common.shared_kernel.Versionable;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.io.Serializable;

@jakarta.persistence.Entity(name="Kontingent")
public class KontingentEntity implements Identifiable, Versionable, Serializable {
    @jakarta.persistence.Id
    public String id;

    @jakarta.persistence.Version
    private Integer version = 0;

    @jakarta.persistence.Column
    private Integer restKontingentOnline = 0;

    @jakarta.persistence.Column
    private Integer restKontingentZentral = 0;

    @jakarta.persistence.Column
    private Integer restKontingentKinokasse = 0;

    @jakarta.persistence.Column
    private String vorfuehrungId;


    protected KontingentEntity() {
    }

    public KontingentEntity(final String id, final Integer version,
                            final Integer restKontingentOnline,
                            final Integer restKontingentZentral,
                            final Integer restKontingentKinokasse,
                            final String vorfuehrungId) {
        this.id = id;
        this.version = version;
        this.restKontingentOnline = restKontingentOnline;
        this.restKontingentZentral = restKontingentZentral;
        this.restKontingentKinokasse = restKontingentKinokasse;
        this.vorfuehrungId = vorfuehrungId;
    }

    @Override
    public Id id() {
        return Identifiable.Id.of(id);
    }

    @Override
    public Version version() {
        return Versionable.Version.of(version);
    }

    public Integer getRestKontingentOnline() {
        return restKontingentOnline;
    }

    public Integer getRestKontingentZentral() {
        return restKontingentZentral;
    }

    public Integer getRestKontingentKinokasse() {
        return restKontingentKinokasse;
    }

    public String getVorfuehrungId() {
        return vorfuehrungId;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) {return true;}

        if (o == null || getClass() != o.getClass()) {return false;}

        KontingentEntity that = (KontingentEntity) o;

        return new EqualsBuilder()
                .append(id, that.id).append(version, that.version)
                .append(restKontingentOnline, that.restKontingentOnline)
                .append(restKontingentZentral, that.restKontingentZentral)
                .append(restKontingentKinokasse, that.restKontingentKinokasse)
                .isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .append(id).append(version)
                .append(restKontingentOnline)
                .append(restKontingentZentral).append(restKontingentKinokasse)
                .toHashCode();
    }
}
